.TH SROAMD 8
.SH NAME
sroamd \- simple roaming daemon
.SH SYNOPSIS
.B sroamd
.IR option ...
[
.B \-\-
]
.IR interface ...
.SH DESCRIPTION
The
.B sroamd
daemon implements a distributed protocol thatmakes it possible to
seamlessly roam between IP links (e.g. WiFi access points) with no changes
to clients.  There is no central controller, and no tunnelling is
involved.

The daemon implements a custom DHCPv4 server, an IPv4 Router Advertisement
(RA) server, and a custom peer-to-peer flooding algorithm.  It requires
an external agent such as
.B hostapd
to perform link-layer configuration, and a routing protocol such as
.I Babel
to distribute host routes within the roaming domain.
.SH OPTIONS
.TP
.BI \-d " level"
Set the verbosity of debugging messages.
.TP
.BI \-P " prefix"
Set the prefix used for roaming clients.  This option may be specified
twice, once with an IPv4 prefix and once with an IPv6 prefix.
.TP
.BI \-N " address"
Configure the nameserver address that will be announced to clients over
DHCPv4 or IPv6 RA.  This option may be specified multiple times, in which
case all prefixes will be announced to clients.
.TP
.BI \-f " port"
Set the server TCP port used by the flooding protocol.  If this is not
set, we don't act as a server.
.TP
.BI \-F " address:port"
Specify the address of a remote peer for the flooding protocol.  There is
no automatic neighbour discovery, you must configure enough peers to
ensure that the network remains connected.  The address must be a unicast
address, either IPv4 or IPv6; in the latter case, the address must be
specified within square brackets.
.SH SEE ALSO
.BR babeld (8).
.SH AUTHOR
Juliusz Chroboczek
 
